/*
 * File name: Lab07.java
 * Date:      2014/08/27 08:31
 * Author:    @author
 */
package cz.cvut.fel.pr1;

public class Lab07 {

    private static final int NUM_COLUMNS = 4;
    private TextIO txtIO;

    public Lab07(TextIO txtIO) {
        this.txtIO = txtIO;
    }

    public void start(String[] args) {
        final String log = "dat/results-jh-l3r5.log";
        // expected column names METHOD, MNE, DISTANCE, CPUTIME
        // expected methods ga, ia, ha, ma
        // expected values of MNE are from the interval 5..20
        processFile(log);
    }

    public boolean processFile(String filename) {
        boolean ret = true;
        txtIO.openFile(filename);
        //print a table with average DISTANCE for each method and MNE
        final String column = "DISTANCE";
        String head = "MNE\t" + "ga" + "\t" + "ia" + "\t" + "ha";
        DoubleValue avg = new DoubleValue();

        System.out.println(head);
        // txtIO.printToFile("my_file.dat", head);
        for (int mne = 5; mne <= 20; ++mne) {
            String row = Integer.toString(mne) + "\t"; //use tabular as column separator
            ret = ret && getAvg(mne, "ga", column, avg); // 1. find the value for ga
            row += String.format("%.1f\t", avg.get());

            ret = ret && getAvg(mne, "ia", column, avg); // 2. find the value for ia
            row += String.format("%.1f\t", avg.get());

            ret = ret && getAvg(mne, "ha", column, avg); // 3. find the value for ha
            row += String.format("%.1f", avg.get());

            System.out.println(row);
            // txtIO.appendToFile("my_file.dat", row);
        } //end for mne
        return ret;
    }

    public boolean getAvg(int mne, String method, String column, DoubleValue avgO) {
        boolean ret = txtIO.resetFile();
        StringValue mneVal = new StringValue();
        StringValue methodVal = new StringValue();
        StringValue value = new StringValue();
        double avg = 0.0;
        int count = 0;
        while (ret && txtIO.readLine(NUM_COLUMNS)) {
            ret
                    = txtIO.getColumnValue("MNE", mneVal)
                    && txtIO.getColumnValue("METHOD", methodVal)
                    && txtIO.getColumnValue(column, value);

            if (ret //parsing the line has been successfull
                    && TextIO.isInteger(mneVal.get()) //mne in the row is interger
                    && mne == Integer.parseInt(mneVal.get()) //mne match
                    && method.equals(methodVal.get()) //method match
                    && TextIO.isDouble(value.get()) //value of the required column is double
                    ) {
                avg += Double.parseDouble(value.get());
                count++;
            } //end parsing
            // you can also compute standard deviation here
        }
        //Uncomment the line bellow to report file processing to the standard error output
        //     System.err.println("getAvg column '" + column + "' for mne: " + mne + " method: '" + method + "' computed from " + count + " values; avg: " + avg);
        if (ret && count > 0) {
            avgO.set(avg / count);
            ret = true; //at least one value of just fine for avg
        }
        return ret;
    }
}
